## ros-noetic-multirobot-map-merge 2.1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(multirobot_map_merge)

## Find catkin macros and libraries
find_package(catkin REQUIRED COMPONENTS
  geometry_msgs
  image_geometry
  map_msgs
  nav_msgs
  roscpp
  tf2_geometry_msgs
)

find_package(Boost REQUIRED COMPONENTS thread)

# OpenCV is required for merging without initial positions
find_package(OpenCV REQUIRED)
if("${OpenCV_VERSION}" VERSION_LESS "3.0")
  message(FATAL_ERROR "This package needs OpenCV >= 3.0")
endif()
if("${OpenCV_VERSION}" VERSION_LESS "4.0")
  message(WARNING "This package supports OpenCV 3, but some features may not be "
    "available. Upgrade to OpenCV 4 to take advantage of all features.")
endif()

################################################
## Declare ROS messages, services and actions ##
################################################
# we don't have any

###################################
## catkin specific configuration ##
###################################
catkin_package(
  CATKIN_DEPENDS
    geometry_msgs
    map_msgs
    nav_msgs
    roscpp
    tf2_geometry_msgs
  DEPENDS
    OpenCV
)

###########
## Build ##
###########
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

## Specify additional locations of header files
include_directories(
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
  ${OpenCV_INCLUDE_DIRS}
  include
)

# we want static linking for now
add_library(combine_grids STATIC
  src/combine_grids/grid_compositor.cpp
  src/combine_grids/grid_warper.cpp
  src/combine_grids/merging_pipeline.cpp
)
add_dependencies(combine_grids ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(combine_grids ${OpenCV_LIBRARIES})

add_executable(map_merge
  src/map_merge.cpp
)
add_dependencies(map_merge ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(map_merge combine_grids ${catkin_LIBRARIES})

#############
## Install ##
#############

# install nodes, installing combine_grids should not be necessary,
# but lets make catkin_lint happy
install(TARGETS combine_grids map_merge
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# install roslaunch files
install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
)

#############
## Testing ##
#############
if(CATKIN_ENABLE_TESTING)
  find_package(roslaunch REQUIRED)

  # download test data
  set(base_url https://raw.githubusercontent.com/hrnr/m-explore-extra/master/map_merge)
  catkin_download_test_data(${PROJECT_NAME}_map00.pgm ${base_url}/hector_maps/map00.pgm MD5 915609a85793ec1375f310d44f2daf87)
  catkin_download_test_data(${PROJECT_NAME}_map05.pgm ${base_url}/hector_maps/map05.pgm MD5 cb9154c9fa3d97e5e992592daca9853a)
  catkin_download_test_data(${PROJECT_NAME}_2011-08-09-12-22-52.pgm ${base_url}/gmapping_maps/2011-08-09-12-22-52.pgm MD5 3c2c38e7dec2b7a67f41069ab58badaa)
  catkin_download_test_data(${PROJECT_NAME}_2012-01-28-11-12-01.pgm ${base_url}/gmapping_maps/2012-01-28-11-12-01.pgm MD5 681e704044889c95e47b0c3aadd81f1e)

  catkin_add_gtest(test_merging_pipeline test/test_merging_pipeline.cpp)
  # ensure that test data are downloaded before we run tests
  add_dependencies(test_merging_pipeline ${PROJECT_NAME}_map00.pgm ${PROJECT_NAME}_map05.pgm ${PROJECT_NAME}_2011-08-09-12-22-52.pgm ${PROJECT_NAME}_2012-01-28-11-12-01.pgm)
  target_link_libraries(test_merging_pipeline combine_grids ${catkin_LIBRARIES})

  # test all launch files
  # do not test from_map_server.launch as we don't want to add dependency on map_server and this
  # launchfile is not critical
  roslaunch_add_file_check(launch/map_merge.launch)
  roslaunch_add_file_check(launch/experiments)
endif()

=== debian/changelog ===
ros-noetic-multirobot-map-merge (2.1.4-1focal) focal; urgency=high

  * use C++14
  * support both OpenCV 3 and OpenCV 4 (support Debian Buster)
  * Contributors: Jiri Horner

 -- Jiri Horner <laeqten@gmail.com>  Wed, 06 Jan 2021 23:00:00 -0000

ros-noetic-multirobot-map-merge (2.1.3-1focal) focal; urgency=high

  * add missing dependencies to catkin_package calls
  * update map_merge for OpenCV 4
  * Contributors: Jiri Horner

 -- Jiri Horner <laeqten@gmail.com>  Sat, 02 Jan 2021 23:00:00 -0000

ros-noetic-multirobot-map-merge (2.1.2-1focal) focal; urgency=high

  * support for ROS Melodic
  * bugfix: zero resolution of the merged grid for known initial posiiton
  * bugfix: estimation_confidence parameter had no effect
  * map_merge: set origin of merged grid in its centre
  * map_merge: add new launch file
    * map_merge with 2 maps served by map_server
  * bugfix: ensure that we never output map with 0 resolution
  * bugfix: nullptr derefence while setting resolution of output grid
  * Contributors: Jiri Horner

 -- Jiri Horner <laeqten@gmail.com>  Fri, 01 Jan 2021 23:00:00 -0000

ros-noetic-multirobot-map-merge (2.1.1-1focal) focal; urgency=high

  * fix bugs in CMakeLists.txt: install nodes in packages, so they get shipped in debian packages. fixes #11 <https://github.com/hrnr/m-explore/issues/11>
  * map_merge: add bibtex to wiki page
  * Contributors: Jiri Horner

 -- Jiri Horner <laeqten@gmail.com>  Fri, 15 Dec 2017 23:00:00 -0000

ros-noetic-multirobot-map-merge (2.1.0-1focal) focal; urgency=high

  * no major changes. Released together with explore_lite.

 -- Jiri Horner <laeqten@gmail.com>  Sun, 29 Oct 2017 23:00:00 -0000

ros-noetic-multirobot-map-merge (2.0.0-1focal) focal; urgency=high

  * map_merge: upgrade to package format 2
  * node completely rewritten based on my work included in opencv
  * uses more reliable features by default -> more robust merging
  * known_init_poses is now by default false to make it easy to start for new users
  * Contributors: Jiri Horner

 -- Jiri Horner <laeqten@gmail.com>  Sat, 25 Mar 2017 23:00:00 -0000

ros-noetic-multirobot-map-merge (1.0.1-1focal) focal; urgency=high

  * map_merge: use inverted tranform
    * transform needs to be inverted before using
  * map_merge: change package description
    * we support merging with unknown initial positions
  * Contributors: Jiri Horner

 -- Jiri Horner <laeqten@gmail.com>  Fri, 24 Mar 2017 23:00:00 -0000

ros-noetic-multirobot-map-merge (1.0.0-1focal) focal; urgency=high

  * initial release
  * Contributors: Jiri Horner

 -- Jiri Horner <laeqten@gmail.com>  Tue, 10 May 2016 22:00:00 -0000

=== debian/control ===
Source: ros-noetic-multirobot-map-merge
Section: misc
Priority: optional
Maintainer: Jiri Horner <laeqten@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-geometry-msgs, ros-noetic-image-geometry, ros-noetic-map-msgs, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-roslaunch, ros-noetic-rosunit, ros-noetic-tf2-geometry-msgs
Homepage: http://wiki.ros.org/multirobot_map_merge
Standards-Version: 3.9.2

Package: ros-noetic-multirobot-map-merge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-geometry-msgs, ros-noetic-image-geometry, ros-noetic-map-msgs, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-tf2-geometry-msgs
Description: Merging multiple maps without knowledge of initial positions of robots.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-multirobot-map-merge//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
